#pragma once

#include <win>
using namespace Win;

template <class T> class Timage
{
protected:
	T *g;
	int w,h;
	int* count;

	void kill();
	void alloc(int _w,int _h);
	void copy(const Timage<T>& I);
public:
	Timage();
	Timage(int _w,int _h);	
	Timage(const Timage<T>& I);
	~Timage();

	const Timage<T>& operator=(const Timage<T>& I);

	Timage<T> clone() const;

	inline int width() const { return w;}
	inline int height() const { return h;}
	inline T operator()(int i,int j) const { return g[i+w*j]; }
	inline T& operator()(int i,int j) { return g[i+w*j]; }
};

class dimage;
class image: public Timage<byte>
{
public:
	image():Timage<byte>() {}
	image(int _w,int _h):Timage<byte>(_w,_h) {}
	image(const Timage<byte>& I):Timage<byte>(I) {}

	image(const dimage& I,bool rescale=false);
	image(const char* name);

	void display(int x=0,int y=0) const;
};

class cimage;
class dimage: public Timage<double>
{
public:
	dimage():Timage<double>() {}
	dimage(int _w,int _h):Timage<double>(_w,_h) {}
	dimage(const Timage<double>& I):Timage<double>(I) {}

	dimage(const image& ima);
	dimage(const cimage& ima,bool phase=false);

	void range(double &m,double &M) const;
	void display(int x=0,int y=0,bool rescale=true) const;
	dimage deriche(int dx,int dy,double alpha) const;
};

//========================================
#include "tools.h"
class cimage: public Timage<complexe>
{
public:
	cimage():Timage<complexe>() {}
	cimage(int _w,int _h):Timage<complexe>(_w,_h) {}
	cimage(const Timage<complexe>& I):Timage<complexe>(I) {}

	cimage(const dimage& ima);

	cimage fft(bool inverse=false) const;
	void display(int x=0,int y=0,bool phase=false) const;
	void logDisplay(int x=0,int y=0) const;
};
