#pragma once

#include <iostream>
#include <math.h>
using namespace std;

class vect
{
	double x[3];
public:
	inline vect() {}
	inline vect(double a,double b,double c) { x[0]=a; x[1]=b; x[2]=c; }
	inline ~vect() {}
	
	inline double operator()(int i)const { return x[i]; }
	inline double& operator()(int i) { return x[i]; }

	friend ostream& operator<<(ostream& f, const vect& v)
	{
	  return f << v.x[0] << ',' << v.x[1] << ',' << v.x[2];
	}
	friend istream& operator>>(istream& f, vect& v)
	{
	  return f >> v.x[0] >> v.x[1] >> v.x[2];
	}
	inline double operator*(const vect&v) const {
		return x[0]*v.x[0]+x[1]*v.x[1]+x[2]*v.x[2];
	}
	inline vect operator^(const vect&v) const {
		vect resultat;
		resultat(0) = x[1]*v(2) - x[2]*v(1);
		resultat(1) = x[2]*v(0) - x[0]*v(2);
		resultat(2) = x[0]*v(1) - x[1]*v(0);
		return resultat;
	}
	inline vect operator*(double l) const { 
		return vect(x[0]*l,x[1]*l,x[2]*l); 
	}
	inline vect operator+(const vect& v) const { 
		return vect(x[0]+v.x[0],x[1]+v.x[1],x[2]+v.x[2]);
	}
	inline vect operator-(const vect& v) const { 
		return vect(x[0]-v.x[0],x[1]-v.x[1],x[2]-v.x[2]);
	}
	inline vect operator-() const { 
		return vect(-x[0],-x[1],-x[2]);
	}
	inline double norme() const {
		return (sqrt (x[0]*x[0] + x[1]*x[1] + x[2]*x[2]));
	}
	vect normalize() const {
		double n=norme();
		if (!n)	return vect(0,0,0);
		return (*this)*(1/n);
	}
};
inline vect operator*(double l,const vect& v) { return v*l;}